/**
 * {}
 * @author yutent<yutent.io@gmail.com>
 * @date 2023/08/10 11:57:38
 */

import { Component } from 'wkit'

export function createStore(obj = {}) {
  window.__wkitd__.set(
    '$store',
    new Proxy(obj, {
      set(target, prop, value) {
        target[prop] = value
        return true
      }
    })
  )

  return function () {
    Object.defineProperty(Component.prototype, '$store', {
      get() {
        return window.__wkitd__.get('$store')
      },
      set(val) {
        console.error('Can not replace readonly property $store of Component')
      },
      enumerable: false
    })
  }
}
